package com.yonge.cooleshow.admin.controller;

import com.alibaba.excel.EasyExcel;
import com.yonge.cooleshow.admin.dto.OmsOrderQueryParam;
import com.yonge.cooleshow.admin.dto.OrderDetailVo;
import com.yonge.cooleshow.admin.service.OmsOrderService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

@RestController
@Api(tags = "数据导出服务")
@RequestMapping("/export")
public class ExportController {
    @Autowired
    private OmsOrderService orderService;

    @ApiOperation("订单详情")
    @RequestMapping(value = "/orderDetail", method = RequestMethod.POST)
    public void orderDetail(@RequestBody OmsOrderQueryParam queryParam, HttpServletResponse response) throws IOException {
        List<OrderDetailVo> orderList = orderService.queryOrderDetail(queryParam);
        // 设置文本内省
        response.setContentType("application/vnd.ms-excel");
        // 设置字符编码
        response.setCharacterEncoding("utf-8");
        // 设置响应头
        response.setHeader("Content-disposition", "attachment;filename=订单详情.xlsx");
        EasyExcel.write(response.getOutputStream(), OrderDetailVo.class).sheet("订单详情").doWrite(orderList);
    }
}
